# -*- coding: utf-8 -*-

import json

from django.test import TestCase
from django.test.client import Client

from django.core.urlresolvers import reverse

from django.contrib.auth.models import User


class UtilisateurTest(TestCase):
    """
    Test l'API qui traite des utilisateurs django.
    """
    client = Client()

    mapping = {
        'username': 'identifiant',
        'email': 'courriel',
        'last_name': 'nom',
        'first_name': 'prenom',
        'is_active': 'actif',
        }

    utilisateurs = [{
        'username': 'user1',
        'first_name': 'prenom1',
        'last_name': 'nom1',
        'email': 'user1@auf.org', }, {

        'username': 'user2',
        'first_name': 'prenom2',
        'last_name': 'nom2',
        'email': 'user2@auf.org', }, ]

    def _creer_utilisateurs(self):
        for user_data in self.utilisateurs:
            User.objects.create(**user_data)

    def test_integrite(self):
        self._creer_utilisateurs()
        url = reverse('pong_utilisateurs')
        response = self.client.get(url)
        self.assertEqual(response.status_code, 200)
        resultset = json.loads(response.content)
        self.assertEqual(len(resultset), 2)
        fields = [f for f in User._meta.get_all_field_names() if f in
                  self.mapping.keys()]
        original = [dict([(self.mapping[f], getattr(u, f)) for f in fields])
                    for u in User.objects.all()]
        for i, data in enumerate(resultset):
            self.assertEqual(cmp(data, original[i]), 0)
